<template>
  <div class="product product-serie">
    <div class="product_content">
      <div class="product_image">
        <a v-if="album.shelf_slug == 'webtoon'">
          <img
            v-if="album.authors"
            :src="
              '/' +
              $i18n.locale +
              '/images/album/' +
              album.id +
              '-h260.jpg?v=' +
              album.version
            "
            :alt="
              album.serie_name +
              ' n° ' +
              album.volume +
              ' - ' +
              album.title +
              ' - ' +
              album.authors[0].nickname
            "
            class="banner-serie_image responsively-lazy"
          />

          <img
            v-else
            :src="
              '/' +
              $i18n.locale +
              '/images/album/' +
              album.id +
              '-h260.jpg?v=' +
              album.version
            "
            :alt="album.title"
            class="banner-serie_image responsively-lazy"
          />
          <span
            v-if="album.banner"
            :class="'product_label text--md product_banner-' + album.banner"
            >{{ $t('catalog.banner.' + album.banner) }}</span
          >
        </a>
        <a v-else :href="album.url">
          <img
            v-if="album.authors"
            :src="
              '/' +
              $i18n.locale +
              '/images/album/' +
              album.id +
              '-h260.jpg?v=' +
              album.version
            "
            :alt="
              album.serie_name +
              ' n° ' +
              album.volume +
              ' - ' +
              album.title +
              ' - ' +
              album.authors[0].nickname
            "
            class="banner-serie_image responsively-lazy"
          />

          <img
            v-else
            :src="
              '/' +
              $i18n.locale +
              '/images/album/' +
              album.id +
              '-h260.jpg?v=' +
              album.version
            "
            :alt="album.title"
            class="banner-serie_image responsively-lazy"
          />
          <span
            v-if="album.banner"
            :class="'product_label text--md product_banner-' + album.banner"
            >{{ $t('catalog.banner.' + album.banner) }}</span
          >
        </a>
      </div>
      <div class="product_text">
        <a v-if="album.shelf_slug == 'webtoon'">
          <h3
            v-if="utils.getType(album) == 'volume'"
            class="product_title text text--xl text--primary text--bold"
          >
            {{
              $t('serie.volume', 1).charAt(0) +
              album.volume +
              ' ' +
              album.serie_name
            }}
          </h3>
          <h3
            v-else-if="utils.getType(album) == 'chapter'"
            class="product_title text text--xl text--primary text--bold"
          >
            {{
              $t('serie.chapter', 1).charAt(0) +
              album.chapter +
              ' ' +
              album.serie_name
            }}
          </h3>
          <h3
            v-else
            class="product_title text text--xl text--primary text--bold"
          >
            {{ album.title }}
          </h3>
        </a>
        <a v-else :href="album.url">
          <h3
            v-if="utils.getType(album) == 'volume'"
            class="product_title text text--xl text--primary text--bold"
          >
            {{
              $t('serie.volume', 1).charAt(0) +
              album.volume +
              ' ' +
              album.serie_name
            }}
          </h3>
          <h3
            v-else-if="utils.getType(album) == 'chapter'"
            class="product_title text text--xl text--primary text--bold"
          >
            {{
              $t('serie.chapter', 1).charAt(0) +
              album.chapter +
              ' ' +
              album.serie_name
            }}
          </h3>
          <h3
            v-else
            class="product_title text text--xl text--primary text--bold"
          >
            {{ album.title }}
          </h3>
        </a>

        <starrank :avgstar="album.rate" :countnote="album.rate_amount" />

        <p
          v-if="album.shelf_slug == 'webtoon'"
          class="product_desc text text--sm text--primary text--medium"
        >
          <span v-html="album.Synopsis"></span>
        </p>

        <p v-else class="product_desc text text--sm text--primary text--medium">
          <span v-html="truncateText(album.Synopsis)"></span>
          <a :href="album.url" class="read-more">{{ $t('serie.read_more') }}</a>
        </p>
      </div>
    </div>
    <div class="product_infos">
      <p
        v-if="!album.inCollection && !album.inSubscription && !album.inCart"
        class="product_price text text--sm text--xl"
      >
        <span v-if="album.oldprice != 'N/A'">
          <del v-html="album.oldpriceHTML"></del>&nbsp;
        </span>
        <span style="opacity: 1 !important" v-html="album.priceHTML"></span>
      </p>
      <a
        v-if="album.inCollection && !album.inSubscription"
        :href="getPlayerURL()"
        class="button button_orange"
        >{{ $t('serie.read_album') }}</a
      >
      <a
        v-else-if="album.inSubscription"
        :href="getPlayerURL()"
        class="button button_blue"
        >{{ $t('serie.read_album') }}</a
      >
      <a
        v-else-if="album.inCart"
        class="button button_shape_grey button_mb"
        @click="addToCart()"
        >{{ $t('catalog.added_basket') }}</a
      >
      <a
        v-else-if="album.status == 'preorder'"
        class="button button_orange"
        :data-price="responsivePrice(album)"
        @click="addToCart()"
        >{{ $t('serie.preorder') }}</a
      >
      <a
        v-else
        :data-id="album.id"
        class="button button_orange"
        :data-price="responsivePrice(album)"
        @click="addToCart()"
        >{{ $t('catalog.add_basket') }}</a
      >
      <a
        v-if="album.inSubscription && !album.isBuyer && isLibrary"
        class="button button_shape_grey"
        @click="addToLibrary()"
        >{{
          $t('catalog.' + (album.inCollection ? 'remove' : 'add') + '_library')
        }}</a
      >
      <a
        v-else-if="
          album.previewAvailable && !album.inCollection && !album.inSubscription
        "
        :href="getPlayerURL()"
        class="button button_shape_grey"
        >{{ $t('serie.read_preview') }}</a
      >
    </div>
  </div>
</template>

<script>
import starrank from '@/components/ui/StarRank'

export default {
  name: 'Largealbum',
  components: { starrank },
  props: {
    album: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      isLibrary: true
    }
  },
  methods: {
    truncateText(value) {
      let text = value
      if (text.length > 200) {
        text = text.slice(0, 200)
        text =
          text.substr(0, Math.min(text.length, text.lastIndexOf(' '))) + '...'
      }

      return '‘‘' + text + '‘‘'
    },
    responsivePrice(album) {
      return (
        ' ' +
        this.$t('serie.for') +
        ' ' +
        this.utils.getPrettyPrice(album.price, album.currency)
      )
    },
    getPlayerURL() {
      if (this.userInfo.isBetaTester())
        return this.utils.generateNewPlayerUrl(this.album.url, document.URL)
      else
        return this.utils.generatePlayerUrl(
          this.album.ean,
          window.location.hostname,
          document.URL
        )
    },
    addToCart() {
      const item = this

      /*if(!item.album.inCart){
        gtag('event', 'Panier', {
          'event_category': 'add_cart',
          'event_label'   : 'Add to cart (from serie page)',
        });
      }*/

      const params = new URLSearchParams()
      params.append('album_id', parseInt(item.album.id))
      this.axios
        .post(
          item.album.inCart
            ? Routing.generate('izneo_front_cartitem_removeone')
            : Routing.generate('izneo_front_cartitem_add'),
          params
        )
        .then((response) => {
          if (response.status == 200) {
            item.album.inCart = !item.album.inCart
            item.$forceUpdate()
            $('.icon.icon-cart.icon-cart-not-empty').attr(
              'data-cart',
              response.data.count
            )
          }
        })
        .catch((error) => {
          console.log(error.response)
        })
    },
    addToLibrary() {
      const item = this
      const params = new URLSearchParams()
      params.append('album_id', parseInt(item.album.id))
      this.axios
        .post(
          item.album.inCollection
            ? Routing.generate('izneo_front_library_remove')
            : Routing.generate('izneo_front_library_add'),
          params
        )
        .then((response) => {
          if (response.status == 200) {
            item.album.inCollection = !item.album.inCollection
            item.$forceUpdate()
          }
        })
        .catch((error) => {
          console.log(error.response)
        })
    }
  }
}
</script>

<style scoped lang="scss">
.button_blue {
  margin-bottom: 10px;
}

.button {
  cursor: pointer;
}

.product-serie {
  display: flex !important;
  pointer-events: auto !important;
}

.button_mb {
  margin-bottom: 10px;
}

@media only screen and (max-width: 767px) {
  .product-serie .product_infos .button_orange:after {
    white-space: pre;
  }
}

@media only screen and (max-width: 479px) {
  .product-serie .product_desc {
    text-align: left;
  }
}
</style>
